module.exports =
/******/ (function(modules) { // webpackBootstrap
/******/ 	// The module cache
/******/ 	var installedModules = {};
/******/
/******/ 	// The require function
/******/ 	function __webpack_require__(moduleId) {
/******/
/******/ 		// Check if module is in cache
/******/ 		if(installedModules[moduleId]) {
/******/ 			return installedModules[moduleId].exports;
/******/ 		}
/******/ 		// Create a new module (and put it into the cache)
/******/ 		var module = installedModules[moduleId] = {
/******/ 			i: moduleId,
/******/ 			l: false,
/******/ 			exports: {}
/******/ 		};
/******/
/******/ 		// Execute the module function
/******/ 		modules[moduleId].call(module.exports, module, module.exports, __webpack_require__);
/******/
/******/ 		// Flag the module as loaded
/******/ 		module.l = true;
/******/
/******/ 		// Return the exports of the module
/******/ 		return module.exports;
/******/ 	}
/******/
/******/
/******/ 	// expose the modules object (__webpack_modules__)
/******/ 	__webpack_require__.m = modules;
/******/
/******/ 	// expose the module cache
/******/ 	__webpack_require__.c = installedModules;
/******/
/******/ 	// define getter function for harmony exports
/******/ 	__webpack_require__.d = function(exports, name, getter) {
/******/ 		if(!__webpack_require__.o(exports, name)) {
/******/ 			Object.defineProperty(exports, name, { enumerable: true, get: getter });
/******/ 		}
/******/ 	};
/******/
/******/ 	// define __esModule on exports
/******/ 	__webpack_require__.r = function(exports) {
/******/ 		if(typeof Symbol !== 'undefined' && Symbol.toStringTag) {
/******/ 			Object.defineProperty(exports, Symbol.toStringTag, { value: 'Module' });
/******/ 		}
/******/ 		Object.defineProperty(exports, '__esModule', { value: true });
/******/ 	};
/******/
/******/ 	// create a fake namespace object
/******/ 	// mode & 1: value is a module id, require it
/******/ 	// mode & 2: merge all properties of value into the ns
/******/ 	// mode & 4: return value when already ns object
/******/ 	// mode & 8|1: behave like require
/******/ 	__webpack_require__.t = function(value, mode) {
/******/ 		if(mode & 1) value = __webpack_require__(value);
/******/ 		if(mode & 8) return value;
/******/ 		if((mode & 4) && typeof value === 'object' && value && value.__esModule) return value;
/******/ 		var ns = Object.create(null);
/******/ 		__webpack_require__.r(ns);
/******/ 		Object.defineProperty(ns, 'default', { enumerable: true, value: value });
/******/ 		if(mode & 2 && typeof value != 'string') for(var key in value) __webpack_require__.d(ns, key, function(key) { return value[key]; }.bind(null, key));
/******/ 		return ns;
/******/ 	};
/******/
/******/ 	// getDefaultExport function for compatibility with non-harmony modules
/******/ 	__webpack_require__.n = function(module) {
/******/ 		var getter = module && module.__esModule ?
/******/ 			function getDefault() { return module['default']; } :
/******/ 			function getModuleExports() { return module; };
/******/ 		__webpack_require__.d(getter, 'a', getter);
/******/ 		return getter;
/******/ 	};
/******/
/******/ 	// Object.prototype.hasOwnProperty.call
/******/ 	__webpack_require__.o = function(object, property) { return Object.prototype.hasOwnProperty.call(object, property); };
/******/
/******/ 	// __webpack_public_path__
/******/ 	__webpack_require__.p = "";
/******/
/******/
/******/ 	// Load entry module and return exports
/******/ 	return __webpack_require__(__webpack_require__.s = 0);
/******/ })
/************************************************************************/
/******/ ({

/***/ "./src/advance-to-block.js":
/*!*********************************!*\
  !*** ./src/advance-to-block.js ***!
  \*********************************/
/*! no static exports found */
/***/ (function(module, exports, __webpack_require__) {

"use strict";


Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.advanceBlock = advanceBlock;
exports.advanceToBlock = void 0;

var _compat = __webpack_require__(/*! ./compat */ "./src/compat.js");

var _latestTime = __webpack_require__(/*! ./latest-time */ "./src/latest-time.js");

function advanceBlock() {
  return new Promise((resolve, reject) => {
    const payload = {
      jsonrpc: '2.0',
      method: 'evm_mine',
      id: Date.now()
    };
    (0, _compat.wrapPayloadToCompat)({
      resolve,
      reject,
      payload
    });
  });
}

const getBlockNumber = async () => {
  const block = await (0, _latestTime.getLatestBlock)();
  return block.number;
};

const advanceToBlock = async number => {
  let blockNumber = await getBlockNumber();

  if (blockNumber > number) {
    throw Error(`block number ${number} is in the past (current is ${blockNumber})`);
  }

  while (blockNumber < number) {
    await advanceBlock();
    blockNumber = await getBlockNumber();
  }
};

exports.advanceToBlock = advanceToBlock;

/***/ }),

/***/ "./src/compat.js":
/*!***********************!*\
  !*** ./src/compat.js ***!
  \***********************/
/*! no static exports found */
/***/ (function(module, exports, __webpack_require__) {

"use strict";


Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.wrapPayloadToCompat = void 0;

var _web = __webpack_require__(/*! ./web3 */ "./src/web3.js");

const oldSend = 'sendAsync';
const newSend = 'send';
const newerSend = 'sendPayload';
const methodReturnPromise = 'promise';
const methodReturnCallback = 'callback';

const getSendMethodName = () => {
  let methodName;
  let methodReturnType;

  const _web3 = (0, _web.getWeb3)();

  if (typeof _web3.currentProvider[newerSend] === 'function') {
    methodName = newerSend;
    methodReturnType = methodReturnPromise;
  } else if (typeof _web3.currentProvider[oldSend] === 'function') {
    methodName = oldSend;
    methodReturnType = methodReturnCallback;
  } else {
    methodName = newSend;
    methodReturnType = methodReturnCallback;
  }

  return {
    methodName,
    methodReturnType
  };
};

const wrapPayloadToCompat = ({
  payload,
  resolve,
  reject
}) => {
  const {
    methodName,
    methodReturnType
  } = getSendMethodName();

  const _web3 = (0, _web.getWeb3)();

  let cb;

  if (methodReturnType !== methodReturnPromise) {
    cb = (err, res) => {
      return err ? reject(err) : resolve(res);
    };
  }

  const potentialPromise = _web3.currentProvider[methodName](payload, cb);

  if (methodReturnType === methodReturnPromise) {
    potentialPromise.catch(e => reject(e)).then(res => resolve(res));
  }
};

exports.wrapPayloadToCompat = wrapPayloadToCompat;

/***/ }),

/***/ "./src/evm-revert.js":
/*!***************************!*\
  !*** ./src/evm-revert.js ***!
  \***************************/
/*! no static exports found */
/***/ (function(module, exports, __webpack_require__) {

"use strict";


Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;
var _default = 'revert';
exports.default = _default;

/***/ }),

/***/ "./src/increase-time.js":
/*!******************************!*\
  !*** ./src/increase-time.js ***!
  \******************************/
/*! no static exports found */
/***/ (function(module, exports, __webpack_require__) {

"use strict";


Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.duration = exports.increaseTimeTo = exports.increaseTime = void 0;

var _latestTime = _interopRequireDefault(__webpack_require__(/*! ./latest-time */ "./src/latest-time.js"));

var _compat = __webpack_require__(/*! ./compat */ "./src/compat.js");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

const increaseTime = duration => {
  const id = Date.now();
  return new Promise((resolve, reject) => {
    const payloadIncreaseTime = {
      jsonrpc: '2.0',
      method: 'evm_increaseTime',
      params: [duration],
      id: id
    };

    const mineNextBlock = () => {
      const nextBlockPayload = {
        jsonrpc: '2.0',
        method: 'evm_mine',
        id: id + 1
      };
      (0, _compat.wrapPayloadToCompat)({
        reject,
        resolve,
        payload: nextBlockPayload
      });
    };

    (0, _compat.wrapPayloadToCompat)({
      reject,
      resolve: mineNextBlock,
      payload: payloadIncreaseTime
    });
  });
};

exports.increaseTime = increaseTime;

const increaseTimeTo = async target => {
  const now = await (0, _latestTime.default)();

  if (target < now) {
    throw Error(`Cannot increase current time(${now}) to a moment in the past(${target})`);
  }

  const diff = target - now;
  return increaseTime(diff);
};

exports.increaseTimeTo = increaseTimeTo;
const duration = {
  seconds: function (val) {
    return val;
  },
  minutes: function (val) {
    return val * this.seconds(60);
  },
  hours: function (val) {
    return val * this.minutes(60);
  },
  days: function (val) {
    return val * this.hours(24);
  },
  weeks: function (val) {
    return val * this.days(7);
  },
  years: function (val) {
    return val * this.days(365);
  }
};
exports.duration = duration;

/***/ }),

/***/ "./src/index.js":
/*!**********************!*\
  !*** ./src/index.js ***!
  \**********************/
/*! no static exports found */
/***/ (function(module, exports, __webpack_require__) {

"use strict";


Object.defineProperty(exports, "__esModule", {
  value: true
});
Object.defineProperty(exports, "advanceBlock", {
  enumerable: true,
  get: function () {
    return _advanceToBlock.advanceBlock;
  }
});
Object.defineProperty(exports, "advanceToBlock", {
  enumerable: true,
  get: function () {
    return _advanceToBlock.advanceToBlock;
  }
});
Object.defineProperty(exports, "increaseTime", {
  enumerable: true,
  get: function () {
    return _increaseTime.increaseTime;
  }
});
Object.defineProperty(exports, "increaseTimeTo", {
  enumerable: true,
  get: function () {
    return _increaseTime.increaseTimeTo;
  }
});
Object.defineProperty(exports, "duration", {
  enumerable: true,
  get: function () {
    return _increaseTime.duration;
  }
});
Object.defineProperty(exports, "revert", {
  enumerable: true,
  get: function () {
    return _evmRevert.default;
  }
});
Object.defineProperty(exports, "latestTime", {
  enumerable: true,
  get: function () {
    return _latestTime.default;
  }
});
Object.defineProperty(exports, "setWeb3", {
  enumerable: true,
  get: function () {
    return _web.setWeb3;
  }
});

var _advanceToBlock = __webpack_require__(/*! ./advance-to-block */ "./src/advance-to-block.js");

var _increaseTime = __webpack_require__(/*! ./increase-time */ "./src/increase-time.js");

var _evmRevert = _interopRequireDefault(__webpack_require__(/*! ./evm-revert */ "./src/evm-revert.js"));

var _latestTime = _interopRequireDefault(__webpack_require__(/*! ./latest-time */ "./src/latest-time.js"));

var _web = __webpack_require__(/*! ./web3 */ "./src/web3.js");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

/***/ }),

/***/ "./src/latest-time.js":
/*!****************************!*\
  !*** ./src/latest-time.js ***!
  \****************************/
/*! no static exports found */
/***/ (function(module, exports, __webpack_require__) {

"use strict";


Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = exports.getLatestBlock = void 0;

var _web = __webpack_require__(/*! ./web3 */ "./src/web3.js");

const getLatestBlock = () => new Promise(resolve => {
  const _web3 = (0, _web.getWeb3)();

  const blockP = _web3.eth.getBlock('latest'); // Promise check


  if (typeof blockP.then === 'function') {
    // web3=1.0
    blockP.then(block => {
      resolve(block);
    });
  } else {
    // web3=0.22
    resolve(blockP);
  }
});

exports.getLatestBlock = getLatestBlock;

const latestTime = async () => {
  const block = await getLatestBlock();
  return block.timestamp;
};

var _default = latestTime;
exports.default = _default;

/***/ }),

/***/ "./src/web3.js":
/*!*********************!*\
  !*** ./src/web3.js ***!
  \*********************/
/*! no static exports found */
/***/ (function(module, exports, __webpack_require__) {

"use strict";


Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.setWeb3 = exports.getWeb3 = void 0;

let _web3 = typeof web3 === 'undefined' ? null : web3;

const getWeb3 = () => _web3;

exports.getWeb3 = getWeb3;

const setWeb3 = web3Instance => {
  _web3 = web3Instance;
};

exports.setWeb3 = setWeb3;

/***/ }),

/***/ 0:
/*!****************************!*\
  !*** multi ./src/index.js ***!
  \****************************/
/*! no static exports found */
/***/ (function(module, exports, __webpack_require__) {

module.exports = __webpack_require__(/*! /Users/petrkosikhin/Work/open-source/truffle-test-helpers/src/index.js */"./src/index.js");


/***/ })

/******/ });